#ifndef FITNESS_H
#define FITNESS_H

#include <eo>
#include <iostream>   // cout
#include <fstream>
#include <vector>

using namespace std;


// REPRESENTATION 
//-----------------------------------------------------------------------------
// define your individuals

class MyIndividual : public EO<double> {

public:
  
  int operator[](int i) const { return classes[i]; } 
  int& operator[](int i)  { return classes[i]; } 

  void resize(int N) { classes.resize(N);  }
  unsigned size() const { return classes.size(); }

  virtual std::string className() const {
    return "MyIndividual";
  }
 
  virtual void printOn(std::ostream& os) const {
    EO<double>::printOn(os);
    for (unsigned i=0; i<classes.size(); i++) 
      os << " " << classes[i]; 
  }
  
  virtual void readFrom(std::istream& is)   {
    // not implemented
  }

private:
  vector<int> classes;
}; 




// FITNESS FUNCTION 
class MyFitness :  public eoEvalFunc<MyIndividual> {

public:
  MyFitness(string _fileName,int _K) : fileName(_fileName), K(_K) {

  };


  // todo: prepiste tento operator, aby pocital fitness k problemu "hromadkovani"
   virtual void operator() (MyIndividual& ind)   {
     if (ind.invalid()) {
       
       // vypocet fitness

       ind.fitness( 42  );  // prirazeni hodnoty 
     }
   };
     

 private:
  string fileName;
  int K;
};

#endif
